% Demo form graph-clustering

% Generate synthetic network
N=[2000 1000 500 250];
rho=0.05*diag(0.5*rand(size(N))+0.5);
noise=0.01*ones(length(N));
rho=rho+noise;
A=generatesynthnetwork(N,rho);
figure('name','True network'); 
spy(A);
% Random permute graph
ind=randperm(size(A,1));
A=A(:,ind);
A=A(ind,:);


% Modularity optimization
opts.meth='Modularity';
[Qbc,Sbc,Qsr,Ssr]=sr_clustering_gc(A,10,opts);
[Asorted,Ssorted]=sortNetwork(A,Ssr);

figure('name','Modularity optimization');
subplot(1,2,1); spy(A);
title('Analyzed Network')
subplot(1,2,2); spy(Asorted);
title('Permuted Network')

% Hamiltonian optimization
opts.meth='Hamiltonian';
[Qbc,Sbc,Qsr,Ssr]=sr_clustering_gc(A,10,opts);

[Asorted,Ssorted]=sortNetwork(A,Ssr);

figure('name','Hamiltonian optimization');
subplot(1,2,1); spy(A);
title('Analyzed Network')
subplot(1,2,2); spy(Asorted);
title('Permuted Network')